/*
var Super = function(owner, sup) {
   for(var fn in sup.prototype) {
      if(sup.prototype.hasOwnProperty(fn) &&
         sup.prototype[fn] instanceof Function) {
         this[fn] =
            (function(v) {
               return function() { sup.prototype[v].apply(owner, arguments); };
             })(fn);
      }
   }
};


var SuperTwo = function(owner) {
   var sup = owner.__proto__.__proto__;
   for(var fn in sup) {
      if(sup.hasOwnProperty(fn) && sup[fn] instanceof Function) {
         this[fn] =
            (function(v) {
               return function() { sup[v].apply(owner, arguments); };
             })(fn);
      }
   }
};

var A = function() { this.a = "a"; }
A.prototype.foo = function() { print(this.a); };

var B = function() { this.b = "b"; }
B.prototype = new A();
B.prototype.foo = function() { print(this.b); };

var a = new A();
var b = new B();
b.$super = new Super(b);

*/

//-----------------------------------------------------------------------------

/*
var SuperPrime = function(owner, sup) {
   for(var fn in sup) {
      if(sup.hasOwnProperty(fn) && sup[fn] instanceof Function) {
         this[fn] =
            (function(v) {
               return function() { sup[v].apply(owner, arguments); };
             })(fn);
      }
   }
   
   if(sup.__proto__ && sup.__proto__ !== Object.prototype)
     this.$super = new SuperPrime(owner, sup.__proto__);
};

var SuperThree = function(owner) {
   SuperPrime.apply(this, [owner, owner.__proto__.__proto__]);
};
*/

var SuperThree = function(owner) {
   var SuperPrime = function(owner, sup) {
      for(var fn in sup) {
         if(sup.hasOwnProperty(fn) && sup[fn] instanceof Function) {
            this[fn] =
               (function(v) {
                  return function() { sup[v].apply(owner, arguments); };
                })(fn);
         }
      }
   
      if(sup.__proto__ && sup.__proto__ !== Object.prototype)
         this.$super = new SuperPrime(owner, sup.__proto__);
   };

   SuperPrime.apply(this, [owner, owner.__proto__.__proto__]);
};

var A = function() { this.a = "a"; }
A.prototype.foo = function() { print(this.a); };

var B = function() { this.b = "b"; this.$super = new SuperThree(this); }
B.prototype = new A();
B.prototype.foo = function() { print(this.b); };

var C = function() { this.c = "c"; this.$super = new SuperThree(this); }
C.prototype = new B();
C.prototype.foo = function() { print(this.c); };

var a = new A();
var b = new B();
var c = new C();
